#include <EEPROM.h>
#include <nRF24L01.h>
#include <printf.h>
#include <RF24.h>
#include <RF24_config.h>
#include <SPI.h>
#include <TinyGPS++.h>
#include <SoftwareSerial.h>

RF24 radio(7,8);

String bericht = "";
String xas = "";
String yas = "";
int intyas = 507;
int intxas= 507;
const uint64_t luisteraddress = 0xE0E0F1F1E0LL;
const uint64_t schrijfaddress = 0xF1F1F0F0F0LL;
int enable = 6;
int in1 = 2;
int in2 = 5;
int water = A0;
static const int RXPin=4,TXPin=3;
String stuurbericht = "";

TinyGPSPlus gps;
SoftwareSerial ss(RXPin,TXPin);

void setup() {
  pinMode(enable,OUTPUT);
  pinMode(in1,OUTPUT);
  pinMode(in2,OUTPUT);
  Serial.begin(9600);
  Serial2.begin(9600);
  radio.begin();
  ss.begin(9600);
  radio.setPALevel(RF24_PA_MIN);
  radio.setChannel(0x76);
  radio.openReadingPipe(0,luisteraddress);
  radio.openWritingPipe(schrijfaddress);
}

void loop() {
  radio.startListening();
  if(radio.available()){ 
    char ingekomen[32] = "";
    radio.read(&ingekomen, sizeof(ingekomen));

    bericht = String(ingekomen);
    xas = bericht.substring(0, bericht.indexOf(','));
    yas = bericht.substring(bericht.indexOf(',') + 1);
    //Serial.println("yas: " + yas);
    intyas = yas.toInt();
    intxas = xas.toInt();
    
    int voorsom = (intyas-520)/503.0*255;
    int achtersom = (500-intyas)/500.0 *255;

    for(int i=0; i<2; i++) {
      digitalWrite(9, HIGH);
      delayMicroseconds(500 + (intxas * 1.5));
      digitalWrite(9, LOW);
      delay(25);
    }
    
    if(intyas > 520){
      digitalWrite(2,HIGH);
      digitalWrite(5,LOW);
      analogWrite(enable,voorsom);
    }
    else if(intyas < 500){
      digitalWrite(in2,HIGH);
      digitalWrite(in1,LOW);
      analogWrite(enable,achtersom);
    }
    else{
      analogWrite(enable,0);
    }
    
   
    
    radio.stopListening();
    if (Serial2.available() > 0){
    gps.encode(Serial2.read());
    if (gps.location.isUpdated()){
      stuurbericht = String(analogRead(water)) + "," + String(gps.location.lat(),6) + "," + String(gps.location.lng(),6);
      char versturen[stuurbericht.length()+1];
    stuurbericht.toCharArray(versturen,stuurbericht.length()+1);
    radio.write(&versturen,sizeof(versturen));
      }}
    }
}
